/*
**********************************************************************************************************************
*											        eGon
*						           the Embedded GO-ON Bootloader System
*									       eGON arm driver sub-system
*
*						  Copyright(C), 2006-2010, SoftWinners Microelectronic Co., Ltd.
*                                           All Rights Reserved
*
* File    : wboot_dma
*
* By      : Jerry
*
* Version : V2.00
*
* Date	  :
*
* Descript:
**********************************************************************************************************************
*/
#ifndef	_WBOOT_DMA_H_
#define	_WBOOT_DMA_H_

typedef enum
{
    NDMA_IR                      = 0,
    NDMA_SPDIF                      ,
    NDMA_IIS                        ,
    NDMA_AC97                       ,
    NDMA_SPI0                       ,
    NDMA_SPI1                       ,
    NDMA_UART0                   = 8,
    NDMA_UART1                      ,
    NDMA_UART2                      ,
    NDMA_UART3                      ,
    NDMA_AUDIO                      ,
    NDMA_TP                         ,
    NDMA_SRAM                   = 16,
    NDMA_SDRAM                      ,
    NDMA_
}
__ndma_drq_type_t;

typedef enum
{
    DDMA_SRC_SRAM                   = 0,
    DDMA_SRC_SDRAM                     ,
    DDMA_SRC_LCD                       ,
    DDMA_SRC_NAND                      ,
    DDMA_SRC_USB0                      ,
    DDMA_SRC_USB1                      ,
    DDMA_SRC_SD0                       ,
    DDMA_SRC_SD1                       ,
    DDMA_SRC_SD2                       ,
    DDMA_SRC_SD3                       ,
    DDMA_SRC_MS                        ,
    DDMA_SRC_EMAC                   = 0xc,
    DDMA_SRC_SS                     = 0xe,
    DDMA_SRC_
}
__ddma_src_type_t;

typedef enum
{
    DDMA_DST_SRAM                   = 0,
    DDMA_DST_SDRAM                     ,
    DDMA_DST_LCD                       ,
    DDMA_DST_NAND                      ,
    DDMA_DST_USB0                      ,
    DDMA_DST_USB1                      ,
    DDMA_DST_SD0                       ,
    DDMA_DST_SD1                       ,
    DDMA_DST_SD2                       ,
    DDMA_DST_SD3                       ,
    DDMA_DST_MS                        ,
    DDMA_DST_EMAC                   = 0xb,
    DDMA_DST_SS                     = 0xd,
    DDMA_DST_
}
__ddma_dst_type_t;

typedef struct  __dma_config_set
{
    unsigned int      src_drq_type     ; //Դַ洢ͣDRAM, SPI,NANDȣѡNDMADDMA, ѡ __ndma_drq_type_t __ddma_src_type_t
    unsigned int      src_addr_type    ; //ԭַ NDMA 0:ģʽ  1:ֲ  DDMA 0:ģʽ  1:ֲ  2:Hģʽ  3:Vģʽ
    unsigned int      src_burst_length ; //һburst 0Ӧ11Ӧ4,
    unsigned int      src_data_width   ; //ݴȣ0:һδ8bit1:һδ16bit2:һδ32bit3:
    unsigned int      dst_drq_type     ; //Դַ洢ͣDRAM, SPI,NANDȣѡNDMADDMA, ѡ __ndma_drq_type_t __ddma_dst_type_t
    unsigned int      dst_addr_type    ; //ԭַ NDMA 0:ģʽ  1:ֲ  DDMA 0:ģʽ  1:ֲ  2:Hģʽ  3:Vģʽ
    unsigned int      dst_burst_length ; //һburst 0Ӧ11Ӧ4,
    unsigned int      dst_data_width   ; //ݴȣ0:һδ8bit1:һδ16bit2:һδ32bit3:
    unsigned int      wait_state       ; //ȴʱӸ ѡΧ0-7ֻNDMAЧ
    unsigned int      continuous_mode  ; //ѡģʽ 0:һμ 1:䣬һDMA¿ʼ
}
__dma_config_t;

typedef struct 	__dma_setting_set
{
    __dma_config_t         cfg;	    	    //DMAò
    unsigned int           pgsz;            //DEʹò鿽ʹ
    unsigned int           pgstp;           //DEʹò鿽ʹ
    unsigned int           cmt_blk_cnt;     //DEʹò鿽ʹ
}__dma_setting_t;

typedef struct  CSP_dma_config
{
    unsigned int      src_drq_type     ; //Դַ洢ͣDRAM, SPI,NANDȣѡNDMADDMA, ѡ __ndma_drq_type_t __ddma_src_type_t
    unsigned int      src_addr_type    ; //ԭַ NDMA 0:ģʽ  1:ֲ  DDMA 0:ģʽ  1:ֲ  2:Hģʽ  3:Vģʽ
    unsigned int      src_burst_length ; //һburst 0Ӧ11Ӧ4,
    unsigned int      src_data_width   ; //ݴȣ0:һδ8bit1:һδ16bit2:һδ32bit3:
    unsigned int      dst_drq_type     ; //Դַ洢ͣDRAM, SPI,NANDȣѡNDMADDMA, ѡ __ndma_drq_type_t __ddma_dst_type_t
    unsigned int      dst_addr_type    ; //ԭַ NDMA 0:ģʽ  1:ֲ  DDMA 0:ģʽ  1:ֲ  2:Hģʽ  3:Vģʽ
    unsigned int      dst_burst_length ; //һburst 0Ӧ11Ӧ4,
    unsigned int      dst_data_width   ; //ݴȣ0:һδ8bit1:һδ16bit2:һδ32bit3:
    unsigned int      wait_state       ; //ȴʱӸ ѡΧ0-7ֻNDMAЧ
    unsigned int      continuous_mode  ; //ѡģʽ 0:һμ 1:䣬һDMA¿ʼ

    unsigned int      cmt_blk_cnt	   ; //DMAcomity counter
}CSP_dma_config_t;

#endif	//_WBOOT_DMA_H_

/* end of _WBOOT_DMA_H_ */

